<template>
  <loader :error="error" :data="myCourses" class="page">
    <row class="absolute-full wrap">
      <column class="fixed-width courses">
        <span class="category">My courses</span>
        <ul>
          <li v-for="course in myCourses.nodes" :key="course.uuid">
            <nuxt-link :to="`/browse/${course.uuid}`">
              {{ course.name || "Unnamed course" }}
              <span v-if="course.public">(public)</span>
            </nuxt-link>
          </li>

          <li class="create">
            <nuxt-link to="/courses/create">Create Course</nuxt-link>

            <nuxt-link to="/courses/import">Import Course</nuxt-link>
          </li>
        </ul>

        <span class="category">Public Courses</span>
        <ul>
          <li v-for="course in publicCourses.nodes" :key="course.uuid">
            <nuxt-link :to="`/browse/${course.uuid}`">
              {{ course.name || "Unnamed course" }}
              <span v-if="course.public">(public)</span>
            </nuxt-link>
          </li>
        </ul>
      </column>
      <column class="grow relative content">
        <client-only>
          <nuxt-child
            class="ui-cell"
            :courses="myCourses.nodes.concat(publicCourses.nodes)"
          />
        </client-only>
      </column>
    </row>
  </loader>
</template>
<style lang="scss" scoped>
@import "~assets/mixins.scss";

.courses {
  margin-left: $grid * 0.5;
  @include scroll;

  @media screen and (max-width: $break-split) {
    max-height: 30%;
  }
}

.category {
  text-transform: uppercase;
  color: $color-whisper;
}

.page {
  position: relative;
  height: 100%;
  display: flex;
}

ul {
  list-style: none;
  padding-left: 0;

  li {
    a {
      text-decoration: none;
      color: $color-text;
      font-weight: 600;
    }
  }
}

.wrap {
  flex-wrap: wrap;
}

.ui-column.fixed-width {
  width: $grid * 15;

  flex-grow: 0;
  flex-shrink: 0;

  @media screen and (max-width: $break-split) {
    width: 100%;
  }
}

.ui-column.grow {
  flex-grow: 1;
}

.content {
  height: 100%;

  @media screen and (max-width: $break-split) {
    height: auto;
    height: 70%;
    min-width: 100%;
  }
}

.relative {
  position: relative;
}
</style>
<script>
import { query } from "~/plugins/data-management";

export default {
  props: [],
  asyncData: query(
    `query ($condition: CourseCondition) {
  myCourses : allCourses(condition: $condition, first:100) {
    nodes { ...fields }
  }
  publicCourses : allCourses(condition: { public: true },first:100) {
    nodes { ...fields }
  }
}

fragment fields on Course {
  name uuid public description
  checkpoints : checkpointsByCourseId(first: 1) {
    nodes {
      lat lng
    }
  }
}
`,
    ({ store }) =>
      store.state.user && store.state.user.id
        ? { condition: { userId: store.state.user.id } }
        : {}
  ),
  data() {
    return {
      error: null,
    };
  },
  computed: {},
  methods: {},
};
</script>
